// Package tree ...
//
// Description : tree ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2023-03-28 18:32
package tree

const (
	// KeywordObjectStart 对象开始标识
	KeywordObjectStart = "{"
	// KeywordObjectEnd 对象结束标识
	KeywordObjectEnd = "}"
	// KeywordArrayStart 数组开始标识
	KeywordArrayStart = "["
	// KeywordArrayEnd 数组结束标识
	KeywordArrayEnd = "]"
	// KeywordColon 冒号
	KeywordColon = ":"
	// KeywordDoubleQuote 双引号
	KeywordDoubleQuote = `"`
	// KeywordEscapeSymbol 转义符号
	KeywordEscapeSymbol = `\`
)

const (
	// ValueTypeString 字符串类型
	ValueTypeString = "string"
	// ValueTypeBool bool类型
	ValueTypeBool = "bool"
	// ValueTypeInteger int类型
	ValueTypeInteger = "int64"
	// ValueTypeFloat float类型
	ValueTypeFloat = "float64"
	// ValueTypeMap map数据
	ValueTypeMap = "map"
	// ValueTypeArray 数组
	ValueTypeArray = "array"
)

// isBaseDataType 是否为基础数据类型
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 23:16 2023/3/28
func isBaseDataType(valueType string) bool {
	return valueType != ValueTypeArray && valueType != ValueTypeMap
}
